math.randomseed(os.time())
require ('camera')
require "json"

function love.load()
   grass = love.graphics.newImage("textures/grass.png") --2
   stone = love.graphics.newImage("textures/stone.png") --3
   dirt = love.graphics.newImage("textures/dirt.png") --4
   grid = love.graphics.newImage("textures/grid.png") --1
   guy_pic = love.graphics.newImage("textures/player_r.png")
   guy_pic_l = love.graphics.newImage("textures/player_l.png")
   guy_pic_f = love.graphics.newImage("textures/player_f_r.png")
   guy_pic_f_l = love.graphics.newImage("textures/player_f_l.png")
   menu = love.graphics.newImage("textures/selected.png")
   sel_menu = love.graphics.newImage("textures/sel_menu.png")
   wood = love.graphics.newImage("textures/wood.png") --5
   plank = love.graphics.newImage("textures/plank.png") --6
   glass = love.graphics.newImage("textures/glass.png") --7
   leaf = love.graphics.newImage("textures/leaves.png") --8
   ladder = love.graphics.newImage("textures/ladder.png") --9
   background = love.graphics.newImage("textures/background.png")--background
   cloud = love.graphics.newImage("textures/cloud.png")--CLOUD
   introscreen = love.graphics.newImage("textures/intro.png")--intro screen
   emblem = love.graphics.newImage("textures/emblem.png")--intro screen
   love.graphics.setIcon(guy_pic)
   width = love.graphics.getWidth()
   height = love.graphics.getHeight()
   camera:setBounds(0, 0, 1920, 1920)
   
   	guy = { --The table for the player
		x = 32,
		y = 32,
		ySpeed = 0,
		grav = 1.5,
		width = 30,
		height = 30,
		direction = 0,
		selected = 1,
		gamestate = "Intro",
		}
		
	tiles = {}
	tiles[1] = grass
	tiles[2] = stone
	tiles[3] = dirt
	tiles[4] = wood
	tiles[5] = plank
	tiles[6] = glass
	tiles[7] = leaf
	tiles[8] = ladder
	tiles[9] = ladder
	
   map = {}
   map.tiles = {}
   map.tiles.width, map.tiles.height = 32, 32 --Tiles width and height
   map.tiles.current = 2 -- This is the currently selected tile, the one you put when you click
   map.width = 80
   map.height = 80
   for x = 0, map.width do
      map[x] = {}
      for y = 0, map.height do
		 if x < 10 then
			map[x][y] = 1
		 elseif x < 11 then
			map[x][y] = math.random(1,2)
			elseif x < 13 then
				map[x][y] = 2
			--The Tree Generation Start
			if map[x][y] == 2 and
			map[x-1][y] == 1 and
			map[x-2][y] == 1 and
			map[x-3][y] == 1 and
			map[x-3][y-1] == 1 and
			map[x-3][y+1] == 1 and
			map[x-3][y-2] == 1 and
			map[x-3][y+2] == 1 and
			map[x-4][y] == 1 and
			math.random(3) == 1 then
			
				map[x-1][y] = 6
				map[x-2][y] = 6
				map[x-3][y] = 8
				map[x-3][y-1] = 8
				map[x-3][y+1] = 8
				map[x-4][y] = 8
			end
			--The Tree Generation End
			
			--The magetree generation start
				if map[x][y] == 2 and
				map[x-1][y] == 1 and
				map[x-2][y] == 1 and
				map[x-3][y] == 1 and
				map[x-4][y] == 1 and
				map[x-5][y] == 1 and
				map[x-6][y] == 1 and
				map[x-6][y-1] == 1 and
				map[x-6][y-1] == 1 and
				map[x-6][y+1] == 1 and
				map[x-6][y+2] == 1 and
				map[x-7][y+1] == 1 and
				map[x-6][y-2] == 1 and
				map[x-7][y-1] == 1 and
				map[x-6][y-3] == 1 and
				map[x-6][y+3] == 1 and
				math.random(4) == 1 then
				
					map[x-7][y] = 8
					map[x-1][y] = 6
					map[x-2][y] = 6
					map[x-3][y] = 6
					map[x-4][y] = 6
					map[x-5][y] = 6
					map[x-6][y] = 6
					map[x-6][y-1] = 8
					map[x-6][y-1] = 8
					map[x-6][y+1] = 8
					map[x-6][y+2] = 8
					map[x-7][y+1] = 8
					map[x-7][y-1] = 8
					map[x-6][y-2] = 8
					map[x-7][y] = 8
				end
				-- the magatree generation end
		 else
			map[x][y] = math.random(3,4)
		 end
		 
		 if map[x][y] == 4 and map[x-1][y] == 1 and x < 15 then
				map[x][y] = 2
		 end
		 
		 --The Great Caves Generation
		 if x > 40 and x < 70 and math.random(5) == 1 then
			map[x][y] = 1
			map[x-1][y] = 1
			map[x-2][y+1] = 1
			map[x][y-1] = 1
		 end
		 
      end
   end
   
   love.graphics.setBackgroundColor(0,204,255)
   
   xcloud = 0
   erot = 0
   numBlocks = 9
end

function love.draw()
	if guy.gamestate == "Game" then
		camera:set()
		love.graphics.draw(background, 0, 0)
		--we draw the clouds
		love.graphics.draw(cloud, xcloud - 192, 32)
		--but only one cloud
		for y = 0, map.height do
			for x = 0, map.width do
				if map[y][x] == 2 then
					if map[y-1][x] > 1 then
						map[y][x] = 4
					end
					love.graphics.draw(grass, x * 32, y * 32)
				end
				if map[y][x] == 3 then
					love.graphics.draw(stone, x * 32, y * 32)
				end
				if map[y][x] == 4 then
					if map[y-1][x] == 1 and (map[y][x+1] == 2 or map[y][x-1] == 2) then
						map[y][x] = 2
					end
					love.graphics.draw(dirt, x * 32, y * 32)
				end
				if map[y][x] == 1 then
				end
				if map[y][x] == 5 then
					love.graphics.draw(wood, x * 32, y * 32)
				end
				if map[y][x] == 6 then
					love.graphics.draw(plank, x * 32, y * 32)
				end
				if map[y][x] == 7 then
					love.graphics.draw(glass, x * 32, y * 32)
				end
				if map[y][x] == 8 then
					love.graphics.draw(leaf, x * 32, y * 32)
				end
				if map[y][x] == 9 then
					love.graphics.draw(ladder, x * 32, y * 32)
				end
			end
		end
		
		if guy.direction == 0 then
			love.graphics.draw(guy_pic, guy.x, guy.y)
		elseif guy.direction == 1 then
			love.graphics.draw(guy_pic_l, guy.x, guy.y)
		end
		camera:unset()
		love.graphics.print("FPS:"..love.timer.getFPS(), 0, 0)
		for i = 1, 9 do
			love.graphics.draw(menu, 160 + i * 32, 0)
			if i == guy.selected then
				love.graphics.draw(sel_menu, 160 + i * 32, 0)
			end
			love.graphics.draw( tiles[i] , 160 + i * 32 + 1, 0 + 1)
		end
	end
	
	if guy.gamestate == "Intro" then
		love.graphics.draw( introscreen, 0, 0 )
		love.graphics.draw( emblem, 670 / 2 - 32, 180, erot )
		love.graphics.print( "Press Any Button to Continue", 670 - 200, 640 - 32)
	end
end

function love.update(dt)

		erot = erot + 4 * dt
	if guy.gamestate == "Game" then	

		xcloud = xcloud + 80 * dt
		
		if xcloud >= 2592 + 192 then
			xcloud = 0 - 192
		end
			
		dt = math.min(dt, 0.07)
		frame = dt * 30
		
		if guy.y < 1 then --Shove him back!!!!!
			guy.y = 1
		end
	    if guy.y > map.height * 32 - ( guy.height / 2 ) then
			guy.y = guy.y - 1
		end
		if guy.x < 1 then
			guy.x = 1
		end
		if guy.x > map.width * 32 - (guy.width / 3) then
			guy.x = guy.x - 9 --This must be more than his speed forward
		end
		
		if mapCollide(guy.x + 12, guy.y) == 9 and love.keyboard.isDown("w") then
			guy.grav = 0
		else
			guy.grav = 1.5
		end
		
		guy.ySpeed = guy.ySpeed + guy.grav * frame
		guy.y = guy.y + guy.ySpeed * frame
		boundingChecks()
		camera:setPosition(guy.x - width / 2, guy.y - height / 2)
	end	
end

function love.keypressed(key) -- 1 = Air; 2 = Grass; 3 = Stone; 4 = Dirt; 5 = Wood; 6 = Planks; 7 = Glass; 8 = Leaves
	if guy.gamestate == "Game" then
		if key == "1" then
			guy.selected = 1
			map.tiles.current = 2
		end
		if key == "2" then
			guy.selected = 2 
			map.tiles.current = 3
		end
		if key == "3" then
			guy.selected = 3 
			map.tiles.current = 4
		end
		if key == "4" then
			guy.selected = 4 
			map.tiles.current = 5
		end
		if key == "5" then
			guy.selected = 5
			map.tiles.current = 6
		end
		if key == "6" then
			guy.selected = 6 
			map.tiles.current = 7
		end
		if key == "7" then
			guy.selected = 7 
			map.tiles.current = 8
		end
		if key == "8" then
			guy.selected = 8 
			map.tiles.current = 9
		end
		if key == "9" then
			guy.selected = 9 
			map.tiles.current = 9
		end

		if key == "w" and guy.ySpeed == 0 then
			guy.ySpeed = -12
		end
	end
	
	if guy.gamestate == "Intro" then
			guy.gamestate = "Game"
	end
end

function love.mousepressed( x, y, button )
    x = camera:RePositionX(x)
	y = camera:RePositionY(y)
	local mapX = math.floor(y/32)
	local mapY = math.floor(x/32)

	if guy.gamestate == "Game" then
		if button == 'l' and y > 32 and mapCollide(x, y) < 2 and ( map[mapX+1][mapY] > 1 or map[mapX-1][mapY] > 1 or map[mapX][mapY+1] > 1 or map[mapX][mapY-1] > 1 ) then
				map[mapX][mapY] = map.tiles.current
		end
		if button == 'r' and y > 32 then
			map[mapX][mapY] = 1
		end
	end

  	if button == "wu" then
      	guy.selected = guy.selected % numBlocks + 1
      	map.tiles.current = map.tiles.current % numBlocks + 1
   	elseif button == "wd" then
      	guy.selected = (guy.selected - 2) % numBlocks + 1
      	map.tiles.current = (map.tiles.current - 2) % numBlocks + 1
	end
end

function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end

function boundingChecks() -- 1 = Air; 2 = Grass; 3 = Stone; 4 = Dirt; 5 = Wood; 6 = Planks; 7 = Glass; 8 = Leaves
	for i = 2, 8 do
		if mapCollide(guy.x + 1, guy.y + guy.height, guy, map) == i or mapCollide(guy.x + guy.width - 1, guy.y + guy.height, guy, map) == i then
			guy.y = guy.y - guy.ySpeed * frame
			guy.ySpeed = 0
		end
		if mapCollide(guy.x + 1, guy.y, guy, map) == i or mapCollide(guy.x + guy.width, guy.y, guy, map) == i then
			guy.ySpeed = .5
		end
	end

	if love.keyboard.isDown("a") then
		guy.x = guy.x - 4 * frame
		guy.direction = 1
	end
	if love.keyboard.isDown("d") then
		guy.x = guy.x + 4 * frame
		guy.direction = 0
	end
	
	for i = 2, 8 do
		if mapCollide(guy.x, guy.y + 1, guy, map) == i or mapCollide(guy.x, guy.y + guy.height - 1, guy, map) == i then
			guy.x = guy.x + 4 * frame
		end
		if mapCollide(guy.x + guy.width, guy.y + 1, guy, map) == i or mapCollide(guy.x + guy.width, guy.y + guy.height - 1, guy, map) == i then
			guy.x = guy.x - 4 * frame
		end
	end
end

function mapCollide(x, y)--qualities
	local checkMap = map[math.floor(y/32)][math.floor(x/32)]
	return checkMap
end

function love.quit()
end